<template>
  <div
    :class="[
      { 'bg-background3 w-full': !widthCustomizeEnabled },
      { 'header-full-width-content': isFullIframe },
      'footer-container mt-auto mx-auto --text3',
    ]"
  >
    <div class="bottom-divider"></div>
    <div
      :class="[
        widthCustomizeEnabled
          ? 'w-[var(--default-width)]'
          : 'container lg:!w-[1200px] !w-full left-0',
        `text-${alignment} mx-auto mt-2 d-common-footer`,
      ]"
    >
      <div
        :class="[informationEnabled ? 'py-8' : 'py-6', 'border-b']"
        v-if="!licenses.IsHidden && informationEnabled"
      >
        <p v-if="informationEnabled" class="flex items-center text-sm">
          {{ licenses.Text }}
          <img
            v-if="selectedThemeName === 'black'"
            class="w-5 h-5 ml-2"
            :src="getAssetImage('assets/theme/common/icon/tick.svg')"
          />
        </p>
        <div
          :class="[
            informationEnabled ? 'mt-4' : '',
            `flex items-center justify-${alignment}`,
          ]"
        >
          <div class="h-10">
            <img :src="licenses.ImagePath" class="object-contain h-full" />
          </div>
        </div>
      </div>
      <div
        :class="[informationEnabled ? 'py-8' : 'py-6', 'border-b']"
        v-if="!providers.IsHidden"
      >
        <p v-if="informationEnabled" class="text-sm">{{ providers.Text }}</p>
        <div
          :class="[
            informationEnabled ? 'mt-4' : '',
            `flex items-center justify-${alignment}`,
          ]"
        >
          <div class="h-10">
            <img :src="providers.ImagePath" class="object-contain h-full" />
          </div>
        </div>
      </div>
      <div
        :class="[informationEnabled ? 'py-8' : 'py-6', 'border-b']"
        v-if="!payments.IsHidden"
      >
        <p v-if="informationEnabled" class="text-sm">{{ payments.Text }}</p>
        <div
          :class="[
            informationEnabled ? 'mt-4' : '',
            `flex items-center justify-${alignment}`,
          ]"
        >
          <div class="h-10">
            <img :src="payments.ImagePath" class="object-contain h-full" />
          </div>
        </div>
      </div>
      <div
        :class="[
          informationEnabled ? 'py-8 border-b' : 'py-3.5',
          `flex flex-wrap lg:flex-nowrap items-center justify-${alignment}`,
        ]"
        v-if="manus.length"
      >
        <div
          v-for="(manu, index) in manus.slice(0, 7)"
          :key="manu"
          class="flex items-center text-sm --text3"
        >
          <div v-if="index !== 0" :class="informationEnabled ? 'mx-2' : 'mx-5'">
            |
          </div>
          <nuxt-link :to="manu.HyperLink">{{ manu.Text }}</nuxt-link>
        </div>
      </div>
      <div
        v-if="informationEnabled && !introduce.IsHidden"
        :class="[informationEnabled ? 'py-8' : 'py-6', 'border-b --text3']"
      >
        <h2 class="--text3 mb-2" >{{ introduce.Text }}</h2>
        <div
          v-if="!introduceContent.IsHidden"
          v-html="introduceContent.Text"
          :class="[
            checkTextLength ? (isReadMore ? 'h-14' : '') : '',
            'truncate leading-7 --text3', {'font-black-theme' : selectedThemeName === 'black'}
          ]"
        ></div>
        <div
          v-if="checkTextLength"
          @click="isReadMore = !isReadMore"
          class="mt-2 underline cursor-pointer"
        >
          {{ isReadMore ? "Read More" : "Hide Information" }}
        </div>
      </div>
      <div class="py-3.5">
        <div
          v-if="selectedThemeName === 'black'"
          class="flex items-center justify-center"
        >
          <div
            v-for="(contact, index) in contactUsAvailable"
            :key="contact.HtmlId"
            @click="handleHyperlinkRender(contact.HyperLink)"
          >
            <img  v-if="index < 3" :src="contact.ImagePath" class="w-6 h-6 m-1 rounded-full" />
          </div>
        </div>
        <div v-if="!copyright.IsHidden" class="flex justify-center">
          <p
            :class="[
              'text-[11.2px]',
              { '--text2': selectedThemeName !== 'black' },
            ]"
          >
            {{ copyright.Text }}
          </p>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import _ from "lodash";
import { ref, computed, PropType, defineComponent } from "vue";
import { store } from "@/store";
import EnumAlignment from "@/models/enums/enumAlignment";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import commonHelper from "@/utils/commonHelper";

export default defineComponent({
  name: "FooterWebsiteInformation",
  props: {
    widthCustomizeEnabled: {
      type: Boolean,
      default: false,
    },
    alignment: {
      type: String as PropType<EnumAlignment>,
      default: EnumAlignment.Left,
      required: true,
    },
    informationEnabled: {
      type: Boolean,
      default: false,
    },
    propertyKeys: {
      type: Array as PropType<Array<string>>,
      required: true,
    },
  },
  setup(props) {
    const isReadMore = ref(true);
    const properties = computed(() => props.propertyKeys);
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const selectedThemeName = computed(() => store.state.selectedThemeName);

    const licenses = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[0]
        )
    );
    const providers = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[1]
        )
    );
    const payments = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[2]
        )
    );
    const manus = computed(
      (): Array<IThemePropertiesFromApi> =>
        themePropertyHelper.getMultipleThemesProperties(
          themeProperties.value,
          properties.value[3]
        )
    );
    const introduce = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[4],
          true
        )
    );
    const introduceContent = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[5]
        )
    );
    const copyright = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[6]
        )
    );
    const checkTextLength = ref(false);
    if (
      introduceContent.value !== undefined &&
      introduceContent.value.Text.length > 650
    ) {
      checkTextLength.value = true;
    }
    const { getContactList: contactUsAvailable } = useContactUs();
    const { getAssetImage, handleHyperlinkRender } = commonHelper;
    const route = useRoute();
    const isFullIframe: Ref<boolean> = ref(
      _.find(["saba", "digi"], (item: string) =>
        _.includes(_.toLower(String(route.query.provider)), item)
      ) !== undefined
    );
    watch(route, () => {
      isFullIframe.value =
        _.find(["saba", "digi"], (item: string) =>
          _.includes(_.toLower(String(route.query.provider)), item)
        ) !== undefined;
    });
    return {
      isReadMore,
      licenses,
      payments,
      providers,
      copyright,
      manus,
      introduce,
      introduceContent,
      selectedThemeName,
      checkTextLength,
      contactUsAvailable,
      handleHyperlinkRender,
      getAssetImage,
      isFullIframe,
    };
  },
});
</script>
<style lang="scss">
@import url("https://fonts.googleapis.com/css2?family=Roboto&display=swap");
.truncate.leading-7,
.truncate.leading-7 p {
  white-space: normal;
  font-size: 12px;
  font-family: "Roboto", sans-serif;
  font-weight: 400;
  line-height: 14px;
  color: var(--text);
}
.truncate.leading-7.font-black-theme p {
  font-size: 14px;
}
.truncate.leading-7.font-black-theme strong {
  font-size: 14px;
  color: var(--text5);
  font-weight: 700;
  margin: 1px 0 -7px;
  display: block;
}
</style>
